-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onInit()
	update();
end

function updateControl(sControl, bReadOnly, bForceHide)
	if not self[sControl] then
		return false;
	end
	
	return self[sControl].update(bReadOnly, bForceHide);
end

function update()
	local bReadOnly = WindowManager.getReadOnlyState(getDatabaseNode());

	race.setReadOnly(bReadOnly);
	class.setReadOnly(bReadOnly);
	level.setReadOnly(bReadOnly);
	
	updateControl("hd", bReadOnly);
	hp.setReadOnly(bReadOnly);
	updateControl("ac", bReadOnly);
	updateControl("move", bReadOnly);
	updateControl("bth", bReadOnly);
	updateControl("atk", bReadOnly);
	updateControl("sa", bReadOnly);
	
	strength.setReadOnly(bReadOnly);
	dexterity.setReadOnly(bReadOnly);
	constitution.setReadOnly(bReadOnly);
	intelligence.setReadOnly(bReadOnly);
	wisdom.setReadOnly(bReadOnly);
	charisma.setReadOnly(bReadOnly);
	
	updateControl("primes", bReadOnly);
	
	updateControl("alignment", bReadOnly);
	updateControl("equipment", bReadOnly);
	updateControl("xp", bReadOnly);
end
