-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

local bShow = true;

function setFilter(bFilter)
	bShow = bFilter;
end

function getFilter()
	return bShow;
end

function onInit()
	if not windowlist.isReadOnly() then
		registerMenuItem(Interface.getString("menu_deletespell"), "delete", 6);
		registerMenuItem(Interface.getString("list_menu_deleteconfirm"), "delete", 6, 7);
	end
end

function update(bEditMode)
	if minisheet then
		return;
	end
	
	idelete.setVisibility(bEditMode);
end

function getActorType()
	return windowlist.window.getActorType();
end	

function onHover(bOver)
	if minisheet then
		if bOver then
			setFrame("rowshade");
		else
			setFrame(nil);
		end
	end
end

function onMenuSelection(selection, subselection)
	if selection == 6 and subselection == 7 then
		getDatabaseNode().delete();
	end
end

function onSpellCounterUpdate()
	windowlist.window.onSpellCounterUpdate();
end

function getDescription()
	local nodeSpell = getDatabaseNode();
	
	local sShort = DB.getValue(nodeSpell, "shortdescription", "");
	if sShort == "" then
		return DB.getValue(nodeSpell, "name", "");
	end

	return DB.getValue(nodeSpell, "name", "") .. " - " .. sShort;
end

function activatePower()
	local nodeSpell = getDatabaseNode();

	if nodeSpell then
		ChatManager.Message(getDescription(), true, ActorManager.getActor(getActorType(), nodeSpell.getChild(".......")));
	end
end

function usePower()
	local nodeSpell = getDatabaseNode();
	local nodeSpellClass = nodeSpell.getChild(".....");

	-- Make sure this is a mana caster
	local nCasterType = DB.getValue(nodeSpellClass, "spontaneous", 0);
	if nCasterType == 2 then
		local nPP = DB.getValue(nodeSpell, ".....mana.total", 0);
		local nPPUsed = DB.getValue(nodeSpell, ".....mana.used", 0);
		local nCost = DB.getValue(nodeSpell, "cost", 0);
		
		local sMessage = DB.getValue(nodeSpell, "name", "") .. " [" .. nCost .. " PP]";
		if (nPP - nPPUsed) < nCost then
			sMessage = sMessage .. " [INSUFFICIENT PP AVAILABLE]";
		else
			nPPUsed = nPPUsed + nCost;
			DB.setValue(nodeSpell, ".....mana.used", "number", nPPUsed);
		end

		local sActorType = getActorType();
		ChatManager.Message(sMessage, true, ActorManager.getActor(sActorType, nodeSpell.getChild(".......")));
	else
		local sName = DB.getValue(nodeSpell, "name", "");
		
		local sActorType = getActorType();
		ChatManager.Message(sName, true, ActorManager.getActor(sActorType, nodeSpell.getChild(".......")));
	end
end
