-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function handleDrop(sTarget, draginfo)
	if sTarget == "npc" then
		local sClass, sRecord = draginfo.getShortcutData();
		if sClass == "monster" then
			local nodeSource = DB.findNode(sRecord);
			local nodeTarget = DB.createChild("npc");
			DB.copyNode(nodeSource, nodeTarget);
	
			convertMonsterToNPC(nodeSource, nodeTarget);
			
			DB.setValue(nodeTarget, "locked", "number", 1);
			return true;
		end
	elseif sTarget == "combattracker" then
		local sClass, sRecord = draginfo.getShortcutData();
		if sClass == "monster" then
			CombatManager.addNPC(sClass, draginfo.getDatabaseNode());
			return true;
		end
	end
end

function convertMonsterToNPC(nodeSource, nodeTarget)
	DB.setValue(nodeTarget, "monster", "string", "true");
	
	DB.setValue(nodeTarget, "monsterhd", "string", DB.getValue(nodeSource, "hd", ""));
	DB.setValue(nodeTarget, "monsterhp", "number", DB.getValue(nodeSource, "hp", 0));
	DB.setValue(nodeTarget, "monstermove", "string", DB.getValue(nodeSource, "move", ""));
	DB.deleteChild(nodeTarget, "move");
	DB.setValue(nodeTarget, "monsterac", "string", DB.getValue(nodeSource, "ac", ""));
	DB.deleteChild(nodeTarget, "ac");
	DB.setValue(nodeTarget, "monsteratk", "string", DB.getValue(nodeSource, "atk", ""));
	DB.setValue(nodeTarget, "monsterintelligence", "string", DB.getValue(nodeSource, "intelligence", ""));
	DB.deleteChild(nodeTarget, "intelligence");
	DB.setValue(nodeTarget, "monsteralignment", "string", DB.getValue(nodeSource, "alignment", ""));
	DB.setValue(nodeTarget, "sa", "string", DB.getValue(nodeSource, "specialattacks", ""));
	DB.deleteChild(nodeTarget, "specialattacks");
end
