-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

actions = {
	["dice"] = { bUseModStack = "true" },
	["table"] = { },
	["init"] = { bUseModStack = "true" },
	["ability"] = { bUseModStack = "true" },
	["attack"] = { sIcon = "action_attack", sTargeting = "each", bUseModStack = "true" },
	["damage"] = { sIcon = "action_damage", sTargeting = "each", bUseModStack = "true" },
	["heal"] = { sIcon = "action_heal", sTargeting = "all", bUseModStack = true },
	["effect"] = { sIcon = "action_effect", sTargeting = "all" }
};

targetactions = {
	"attack",
	"damage",
	"heal",
	"effect"
};

currencies = { "PP", "GP", "SP", "CP" };
currencyDefault = "GP";

abilities = {
	"strength",
	"dexterity",
	"constitution",
	"intelligence",
	"wisdom",
	"charisma"
};

ability_ltos = {
	["strength"] = "STR",
	["dexterity"] = "DEX",
	["constitution"] = "CON",
	["intelligence"] = "INT",
	["wisdom"] = "WIS",
	["charisma"] = "CHA"
};

ability_stol = {
	["STR"] = "strength",
	["DEX"] = "dexterity",
	["CON"] = "constitution",
	["INT"] = "intelligence",
	["WIS"] = "wisdom",
	["CHA"] = "charisma"
};

psabilitydata = {
	"Strength",
	"Dexterity",
	"Constitution",
	"Intelligence",
	"Wisdom",
	"Charisma"
};

rangetypes = {
	"melee",
	"ranged"
};

energytypes = {
	"acid",
	"cold",
	"electricity",
	"fire",
	"poison",
	"sonic"
};

dmgtypes = {
	"acid",  		-- ENERGY DAMAGE TYPES
	"cold",
	"electricity",
	"fire",
	"poison",
	"sonic",
	"adamantine", 	-- WEAPON PROPERTY DAMAGE TYPES
	"bludgeoning",
	"cold iron",
	"magic",
	"mithral",
	"piercing",
	"silver",
	"slashing",
	"nonlethal"
};

immunetypes = {
	"acid",  		-- ENERGY DAMAGE TYPES
	"cold",
	"electricity",
	"fire",
	"poison",
	"sonic",
	"sleep", 		-- OTHER IMMUNITY TYPES
	"paralysis",
	"petrification",
	"charm",
	"sleep",
	"fear",
	"disease"
};

targetableeffectcomps = {
	"CONC1",
	"CONC2",
	"CONC3",
	"CONC4",
	"COVER1",
	"COVER2",
	"COVER3",
	"COVER4",
	"ATK",
	"DMG",
	"AC",
	"IMMUNE",
	"VULN",
	"RESIST"
};

function onInit()
	-- Languages
	languages = {
		[Interface.getString("language_value_common")] = "",
		[Interface.getString("language_value_draconic")] = "Draconic",
		[Interface.getString("language_value_dwarven")] = "Dwarven",
		[Interface.getString("language_value_elven")] = "Elven",
		[Interface.getString("language_value_giant")] = "Dwarven",
		[Interface.getString("language_value_gnome")] = "Dwarven",
		[Interface.getString("language_value_goblin")] = "Dwarven",
		[Interface.getString("language_value_halfling")] = "",
		[Interface.getString("language_value_kobold")] = "Draconic",
		[Interface.getString("language_value_ogre")] = "Dwarven",
		[Interface.getString("language_value_orc")] = "Dwarven",
		[Interface.getString("language_value_sylvan")] = "Elven",
		[Interface.getString("language_value_troll")] = "Dwarven",
	}
	languagefonts = {
		[Interface.getString("language_value_draconic")] = "Draconic",
		[Interface.getString("language_value_dwarven")] = "Dwarven",
		[Interface.getString("language_value_elven")] = "Elven",
	}
end

function getCharSelectDetailHost(nodeChar)
	local sValue = DB.getValue(nodeChar, "classes.slot1.name", "");
	local nLevel = DB.getValue(nodeChar, "classes.slot1.level", 0);
	if nLevel ~= 0 then
		if sValue ~= "" then
			sValue = sValue .. " ";
		end
		sValue = sValue .. nLevel;
	end
	return sValue;
end

function requestCharSelectDetailClient()
	return "name,classes.slot1.name,#classes.slot1.level";
end

function receiveCharSelectDetailClient(vDetails)
	local aVisibleLabels = {};
	if vDetails[2] and vDetails[2] ~= "" then
		table.insert(aVisibleLabels, vDetails[2]);
	end
	if vDetails[3] and vDetails[3] ~= 0 then
		table.insert(aVisibleLabels, vDetails[3]);
	end

	return vDetails[1], table.concat(aVisibleLabels, " ");
end

function getCharSelectDetailLocal(nodeLocal)
	local vDetails = {};
	table.insert(vDetails, DB.getValue(nodeLocal, "name", ""));
	table.insert(vDetails, DB.getValue(nodeLocal, "class.base", ""));
	table.insert(vDetails, DB.getValue(nodeLocal, "level", 0));
	return receiveCharSelectDetailClient(vDetails);
end

function getDistanceUnitsPerGrid()
	return 5;
end

function getAbilityBonus(c)
	if c < 2 then
		return -4;
	elseif c < 4 then
		return -3;
	elseif c < 6 then
		return -2;
	elseif c < 9 then
		return -1;
	elseif c < 13 then
		return 0;
	elseif c < 16 then
		return 1;
	elseif c < 18 then
		return 2;
	elseif c < 20 then
		return 3;
	elseif c < 22 then
		return 4;
	elseif c < 24 then
		return 5;
	elseif c < 26 then
		return 6;
	elseif c < 28 then
		return 7;
	elseif c < 29 then
		return 8;
	elseif c < 30 then
		return 9;
	else
		return 10;
	end
end
