-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onInit()
	PartyLootManager.setItemCostField("value");
	PartyLootManager.setDefaultCurrency("gp");
end

function isWeapon(sClass, vRecord)
	local bIsWeapon = false;

	local nodeItem;
	if type(vRecord) == "string" then
		nodeItem = DB.findNode(vRecord);
	elseif type(vRecord) == "databasenode" then
		nodeItem = vRecord;
	end
	
	local sTypeLower = StringManager.trim(DB.getValue(nodeItem, "itemtype", "")):lower();

	if sClass == "referenceweapon" then
		bIsWeapon = true;
	elseif sClass == "item" then
		if (sTypeLower == "weapon") then
			bIsWeapon = true;
		end
	end
	
	return bIsWeapon, sTypeLower;
end

function addItemToList2(sClass, nodeSource, nodeTarget)
	if LibraryData.isRecordDisplayClass("item", sClass) then
		DB.copyNode(nodeSource, nodeTarget);
		
		if sClass == "referenceweapon" then
			DB.setValue(nodeTarget, "itemtype", "string", "weapon");
		elseif sClass == "referencearmor" then
			DB.setValue(nodeTarget, "itemtype", "string", "armor");
		else
			local nCapacity = DB.getValue(nodeTarget, "evcapacity", 0);
			if nCapacity > 0 then
				DB.setValue(nodeTarget, "itemtype", "string", "container");
			end
		end
		
		DB.setValue(nodeTarget, "isidentified", "number", 1);
		return true;
	end

	return false;
end
