-- Copyright SmiteWorks USA, LLC., 2011 

local versionmsgs = {}

local VersionDetails = {
  major = 3,
  minor = 0,
  maintenance = 11,
  build = 1
}

function onInit()
	local versionmessage = "Castles and Crusades version " .. getVersion() .. " (Build " .. VersionDetails.build .. ")"
	registerMessage({text = versionmessage, font = "systemfont"})
	Comm.registerSlashHandler("version", processVersion)
end

function getVersion()
	return string.format("%d.%d.%d", VersionDetails.major, VersionDetails.minor, VersionDetails.maintenance);
end

function processVersion()
	for keyMessage, rMessage in ipairs(retrieveMessages()) do
		Comm.addChatMessage(rMessage)
	end
end

function registerMessage(msg)
	table.insert(versionmsgs, msg)
end

function retrieveMessages()
	return versionmsgs
end
